


#include "tools.h"

volatile unsigned char data;
unsigned char status;

#define SPI_CS      0     // PB4 	= Select  				->   	PIN 40
#define SPI_SCK     1     // PB7 	= SPI SCK				->		PIN 37
#define SPI_MOSI    2     // PB5 	= SPI MOSI				->		PIN 36
#define SPI_MISO    3     // PB6 	= SPI MISO				->


#define PORT_CS  PORTB
#define DDR_CS   DDRB
#define PIN_CS   0

#define CLR_SS()         PORT_CS &= ~_BV(PIN_CS)
#define SET_SS()         PORT_CS |= _BV(PIN_CS)


static FILE mystdout = FDEV_SETUP_STREAM(usart_putchar, NULL, _FDEV_SETUP_WRITE); // bindet printf() ein


int main(void)
{
	
	
	stdout = &mystdout; // bindet printf() ein

	uart_init();
	slave_init ();
	//master_init ();
	sei ();
	
	printf(" alles ok\r\n");
	
	
	while(true) // main loop
	  {				
	   delay_ms(20);
	   
	  //printf("MasterSend Daten = %c\r\n",Spi_Send('X'));
	   
	  printf("Slave Daten empfangen = %c\r\n",Spi_Io()); ;   
	  delay_ms(20);
	  
	  }
	return 0;
}


int usart_putchar(char c, FILE *stream) //  bindet printf() ein
{
	uart_put(c);
	return 0;
}


uint8_t Spi_Io(void)// Daten vom Slave ausgeben
{
	
			
			
			while(!(SPSR&(1<<SPIF))); //Warten bis gesendet
			data=SPDR;
			return data;
}

	


uint8_t Spi_Send(char Data) // Daten vom Master  senden
{
	
	
	CLR_SS();
	SPDR = Data;
	while ((SPSR & SPIF)==0);
	SET_SS();
	return Data;
}






void slave_init (void)
{
	
	DDRB &= ~((1 << SPI_MOSI)  | (1 << SPI_SCK)| (1 << SPI_CS)); // Eingang
	DDRB |= (1 << SPI_MISO)  ; //MISO Ausgang

	SPCR = (1 << SPE)  ; // Slave enable 
	SPSR |= (0 << SPIF); // SPIF zum Start lschen !
	
	

}

void master_init(void)
{
     
	DDRB = (1 << SPI_MOSI)  | (1 << SPI_SCK)| (1 << SPI_CS);
	PORTB = (1 << SPI_MOSI) | (1 << SPI_SCK)| (1 << SPI_CS);

	SPCR = (1 << SPE) | (1 << MSTR) ;    // 4 MBit SPI

	SPSR |= (1<< SPIF); // SPIF zum Start lschen !
	delay_ms(2);
	SET_SS();
}






